if lca==nil then lca={} end
lca.betabfg={}
lca.betabfg.ball={}

lca.betabfg.gfx_wpn0=loadgfx("weapons/DooM/betabfg_0.png")
setmidhandle(lca.betabfg.gfx_wpn0)
lca.betabfg.gfx_wpn1=loadgfx("weapons/DooM/betabfg_1.png")
setmidhandle(lca.betabfg.gfx_wpn1)
lca.betabfg.gfx_icon=loadgfx("weapons/DooM/betabfg_0.png")
setmidhandle(lca.betabfg.gfx_icon)
lca.betabfg.gfx_pro0=loadgfx("weapons/DooM/BBFG-prj0.png")
setmidhandle(lca.betabfg.gfx_pro0)
lca.betabfg.gfx_pro1=loadgfx("weapons/DooM/BBFG-prj1.png")
setmidhandle(lca.betabfg.gfx_pro1)
lca.betabfg.sfx_attack=loadsfx("bfgshoot.wav")

lca.betabfg.id=addweapon("lca.betabfg","BFG2407",lca.betabfg.gfx_icon, 2, 5)
lca.betabfg.ammo=40

function lca.betabfg.draw()
	setblend(blend_alpha)
	setalpha(1)
	setcolor(255,255,255)
	if lca.betabfg.fire==1 then
	drawinhand(lca.betabfg.gfx_wpn1,6,0)
	else
	drawinhand(lca.betabfg.gfx_wpn0,6,0)
	end
	if weapon_shots==0 then
		hudcrosshair(6,3)
	end
	if lca.betabfg.ammo-weapon_shots>0 then
		hudchargebar(lca.betabfg.ammo-weapon_shots,lca.betabfg.ammo)
	end
end


function lca.betabfg.attack(attack)
    if (attack==1 and weapon_shots==0) then
	 	 	particle(p_lightpuff,getplayerx(0)+(getplayerdirection(0)*5.5)+math.sin(math.rad(getplayerrotation(0)))*16,getplayery(0)+3-math.cos(math.rad(getplayerrotation(0)))*16)
	 	 	particle(p_explosion,getplayerx(0)+(getplayerdirection(0)*5.5)+math.sin(math.rad(getplayerrotation(0)))*16,getplayery(0)+3-math.cos(math.rad(getplayerrotation(0)))*16)
			particlecolor(0,255,0)
			particlealpha(0.6)
			weapon_timer=50
			playsound(lca.betabfg.sfx_attack)
			useweapon(0)
			weapon_mode=1
     end
	 	if weapon_timer>0 then
		weapon_timer=weapon_timer-1
		end
		if weapon_timer==0 and weapon_mode==1 and weapon_shots<40 then
			weapon_timer=3
			id=createprojectile(lca.betabfg.ball.id)
			weapon_shots=weapon_shots+1
			projectiles[id]={}
			projectiles[id].ignore=playercurrent()
			projectiles[id].x=getplayerx(0)+(6*getplayerdirection(0))+math.sin(math.rad(getplayerrotation(0)))*10.0
			projectiles[id].y=getplayery(0)+3-math.cos(math.rad(getplayerrotation(0)))*10.0
			projectiles[id].sx=math.sin(math.rad(getplayerrotation(0)))*random(15,25)
			projectiles[id].sy=-math.cos(math.rad(getplayerrotation(0)))*random(15,25)
			recoil(2)
			if (weapon_shots>=lca.betabfg.ammo) then
			endturn()
			end
        end
    end

lca.betabfg.ball.id=addprojectile("lca.betabfg.ball")

function lca.betabfg.ball.draw(id)
	particle(p_muzzle,projectiles[id].x,projectiles[id].y)
	particlecolor(0,255,0)
	particlealpha(0.6)
	setblend(blend_alpha)
	setalpha(1)
	setcolor(255,255,255)
	setscale(1,1)
	setrotation(math.deg(math.atan2(projectiles[id].sx,-projectiles[id].sy)))
	drawimage(lca.betabfg.gfx_pro0,projectiles[id].x,projectiles[id].y)
	outofscreenarrow(projectiles[id].x,projectiles[id].y)
end

function lca.betabfg.ball.update(id)
	rot=math.deg(math.atan2(projectiles[id].sx,-projectiles[id].sy))
	projectiles[id].sx=projectiles[id].sx+getwind()
	projectiles[id].sy=projectiles[id].sy+getgravity()
	msubt=math.ceil(math.max(math.abs(projectiles[id].sx),math.abs(projectiles[id].sy))/3)
	msubx=projectiles[id].sx/msubt
	msuby=projectiles[id].sy/msubt
	for i=1,msubt,1 do
		projectiles[id].x=projectiles[id].x+msubx
		projectiles[id].y=projectiles[id].y+msuby
		if collision(col3x3,projectiles[id].x+math.sin(math.rad(rot))*3,projectiles[id].y-math.cos(math.rad(rot))*3,1,1)==1 or explode==1 then
			if terraincollision()==1 or objectcollision()>0 or playercollision()~=projectiles[id].ignore or explode==1 then
				arealdamage(projectiles[id].x,projectiles[id].y,30,20)
				terrainexplosion(projectiles[id].x,projectiles[id].y,random(10,30),1)
				grey=math.random(0,40)
				if math.random(0,1)==1 then
					terrainalphaimage(gfx_crater25,projectiles[id].x,projectiles[id].y,math.random(6,9)*0.1,grey,grey,grey)
				else
					terrainalphaimage(gfx_crater50,projectiles[id].x,projectiles[id].y,math.random(6,9)*0.1,grey,grey,grey)
				end
				freeprojectile(id)
				break
			end
		else
			projectiles[id].ignore=0
		end
		if (projectiles[id].y)>getwatery()+5 then
			arealdamage(projectiles[id].x,projectiles[id].y,120,200)
			terrainexplosion(projectiles[id].x,projectiles[id].y,40,1)
			particle(p_waterhit,projectiles[id].x,projectiles[id].y)
			playsound(sfx_hitwater1)
			freeprojectile(id)
			break
		end
	end
	scroll(projectiles[id].x,projectiles[id].y)
end