if lca==nil then lca={} end
lca.bfg={}
lca.bfg.ball={}

lca.bfg.gfx_wpn0=loadgfx("weapons/DooM/BFG_0.png")
setmidhandle(lca.bfg.gfx_wpn0)
lca.bfg.gfx_wpn1=loadgfx("weapons/DooM/BFG_1.png")
setmidhandle(lca.bfg.gfx_wpn1)
lca.bfg.gfx_icon=loadgfx("weapons/DooM/BFG_0.png")
setmidhandle(lca.bfg.gfx_icon)
lca.bfg.gfx_pro=loadgfx("weapons/DooM/bfgball.png")
setmidhandle(lca.bfg.gfx_pro)
lca.bfg.sfx_attack=loadsfx("bfgshoot.wav")

lca.bfg.id=addweapon("lca.bfg","BFG9000",lca.bfg.gfx_icon, 2, 5)
function lca.bfg.draw()
	setblend(blend_alpha)
	setalpha(1)
	setcolor(255,255,255)
	if lca.bfg.fire==1 then
	drawinhand(lca.bfg.gfx_wpn1,6,0)
	else
	drawinhand(lca.bfg.gfx_wpn0,6,0)
	end
	if weapon_shots==0 then
		hudcrosshair(6,3)
	end
end



function lca.bfg.attack(attack)
     if (weapon_shots == 0) then lca.timer = 0 end
     if (attack == 1 and weapon_shots == 0) then
			weapon_shots = weapon_shots + 1
			lca.bfg.fire=1	
	 	 	particle(p_lightpuff,getplayerx(0)+(getplayerdirection(0)*5.5)+math.sin(math.rad(getplayerrotation(0)))*16,getplayery(0)+3-math.cos(math.rad(getplayerrotation(0)))*16)
	 	 	particle(p_explosion,getplayerx(0)+(getplayerdirection(0)*5.5)+math.sin(math.rad(getplayerrotation(0)))*16,getplayery(0)+3-math.cos(math.rad(getplayerrotation(0)))*16)
			particlecolor(0,255,0)
			particlealpha(0.6)
			lca.timer=os.clock()
			playsound(lca.bfg.sfx_attack)
			useweapon(0)
     end
     if (weapon_shots>0 and lca.timer>0 and os.clock()>lca.timer+1) then
          lca.timer = 0
			id=createprojectile(lca.bfg.ball.id)
			projectiles[id]={}
			projectiles[id].ignore=playercurrent()
			projectiles[id].x=getplayerx(0)+(6*getplayerdirection(0))+math.sin(math.rad(getplayerrotation(0)))*10.0
			projectiles[id].y=getplayery(0)+3-math.cos(math.rad(getplayerrotation(0)))*10.0
			projectiles[id].sx=math.sin(math.rad(getplayerrotation(0)))*15.0
			projectiles[id].sy=-math.cos(math.rad(getplayerrotation(0)))*15.0
			recoil(2)
			lca.bfg.fire=0
			endturn()
          end
     end

lca.bfg.ball.id=addprojectile("lca.bfg.ball")

function lca.bfg.ball.draw(id)
	particle(p_muzzle,projectiles[id].x,projectiles[id].y)
	particlecolor(0,255,0)
	particlealpha(0.6)
	setblend(blend_alpha)
	setalpha(1)
	setcolor(255,255,255)
	setscale(1,1)
	setrotation(math.deg(math.atan2(projectiles[id].sx,-projectiles[id].sy)))
	drawimage(lca.bfg.gfx_pro,projectiles[id].x,projectiles[id].y)
	outofscreenarrow(projectiles[id].x,projectiles[id].y)
end

function lca.bfg.ball.update(id)
	rot=math.deg(math.atan2(projectiles[id].sx,-projectiles[id].sy))
	projectiles[id].sx=projectiles[id].sx+getwind()
	projectiles[id].sy=projectiles[id].sy+getgravity()
	msubt=math.ceil(math.max(math.abs(projectiles[id].sx),math.abs(projectiles[id].sy))/3)
	msubx=projectiles[id].sx/msubt
	msuby=projectiles[id].sy/msubt
	for i=1,msubt,1 do
		projectiles[id].x=projectiles[id].x+msubx
		projectiles[id].y=projectiles[id].y+msuby
		if collision(col3x3,projectiles[id].x+math.sin(math.rad(rot))*3,projectiles[id].y-math.cos(math.rad(rot))*3,1,1)==1 or explode==1 then
			--OMFGWTFBBQ
			if terraincollision()==1 or objectcollision()>0 or playercollision()~=projectiles[id].ignore or explode==1 then
				arealdamage(projectiles[id].x,projectiles[id].y,120,400)
				terrainexplosion(projectiles[id].x,projectiles[id].y,40,1)
				grey=math.random(0,40)
				if math.random(0,1)==1 then
					terrainalphaimage(gfx_crater100,projectiles[id].x,projectiles[id].y,math.random(6,9)*0.1,grey,grey,grey)
				else
					terrainalphaimage(gfx_crater125,projectiles[id].x,projectiles[id].y,math.random(6,9)*0.1,grey,grey,grey)
				end
				freeprojectile(id)
				break
			end
		else
			projectiles[id].ignore=0
		end
		if (projectiles[id].y)>getwatery()+5 then
			arealdamage(projectiles[id].x,projectiles[id].y,120,200)
			terrainexplosion(projectiles[id].x,projectiles[id].y,40,1)
			particle(p_waterhit,projectiles[id].x,projectiles[id].y)
			playsound(sfx_hitwater1)
			freeprojectile(id)
			break
		end
	end
	scroll(projectiles[id].x,projectiles[id].y)
end