if lca==nil then lca={} end
lca.d_chainsaw={}

lca.d_chainsaw.gfx_wpn0=loadgfx("weapons/DooM/chain0.png")
setmidhandle(lca.d_chainsaw.gfx_wpn0)
lca.d_chainsaw.gfx_wpn1=loadgfx("weapons/DooM/chain1.png")
setmidhandle(lca.d_chainsaw.gfx_wpn1)
lca.d_chainsaw.sfx_idle=loadsfx("DSSAWIDL.wav")
lca.d_chainsaw.sfx_hitplayer=loadsfx("DSSAWFUL.wav")
lca.d_chainsaw.sfx_hitground=loadsfx("DSSAWHIT.wav")

lca.d_chainsaw.id=addweapon("lca.d_chainsaw","Chainsaw",lca.d_chainsaw.gfx_wpn1,1,1)
lca.d_chainsaw.ammo=100
csawspin=0

function lca.d_chainsaw.draw()
	stopchannel(2)
	if getplayeraction(0)==0 then
		setblend(blend_alpha)
		setalpha(1)
		setcolor(255,255,255)
		setscale(-getplayerdirection(0),1)
		setrotation(getplayerrotation(0)-(30-(weapon_timer*3))*(getplayerdirection(0)))
		if math.random(0,1)==1 then
		drawinhand(lca.d_chainsaw.gfx_wpn0,6,0)
		else
		drawinhand(lca.d_chainsaw.gfx_wpn1,6,0)
		end
	end
	playsound(lca.d_chainsaw.sfx_idle, 1)
	if lca.d_chainsaw.ammo-weapon_shots>0 then
		hudammobar(lca.d_chainsaw.ammo-weapon_shots,lca.d_chainsaw.ammo)
	end
end

function lca.d_chainsaw.attack(attack)
	stopchannel(1)
	if weapon_timer>0 then
		weapon_timer=weapon_timer-1
	end
	if (weapon_shots<lca.d_chainsaw.ammo) and (weapon_timer<=0) then
		if (attack==1) then
			useweapon(0)
			if csawspin==0 then
			playsound(lca.d_chainsaw.sfx_hitplayer,7)
			csawspin=15
			elseif csawspin>0 then
			csawspin=csawspin-1
			end
			weapon_shots=weapon_shots+1
			weapon_timer=5
			if collision(col20x20,getplayerx(0)+getplayerdirection(0)*21,getplayery(0),1,1)==1 then
				if playercollision()~=0 and playercollision()~=playercurrent() then
					playerdamage(playercollision(),1)
					playsound(sfx_splatter1)
					playsound(lca.d_chainsaw.sfx_hitplayer,2)
					blood(getplayerx(0)+getplayerdirection(0)*21,getplayery(0), 5)
				end
				if terraincollision()==1 then
					playsound(lca.d_chainsaw.sfx_hitground,2)
				end
			end
			terrainexplosion((getplayerx(0)+getplayerdirection(0)+math.sin(math.rad(getplayerrotation(0)))*1),getplayery(0)-1-math.cos(math.rad(getplayerrotation(0)))*3,15,2)
			terrainexplosion((getplayerx(0)+getplayerdirection(0)+math.sin(math.rad(getplayerrotation(0)))*10),getplayery(0)-1-math.cos(math.rad(getplayerrotation(0)))*10,15,2)
			if weapon_shots>=lca.d_chainsaw.ammo then
				endturn()
			end
		end
	end
end
