if lca==nil then lca={} end
lca.invis={}

lca.invis.gfx_wpn=loadgfx("weapons/DooM/invisibility.png")
setmidhandle(lca.invis.gfx_wpn)
lca.invis.sfx_heal=loadsfx("DSGETPOW.wav")

lca.invis.id=addweapon("lca.invis","Invisibility sphere",lca.invis.gfx_wpn,0)

function lca.invis.draw()
	if (weapon_shots==0) then
	setblend(blend_alpha)
	setalpha(1)
	setcolor(255,255,255)
	drawinhand(lca.invis.gfx_wpn,6,0)
end
end

function lca.invis.attack(attack)
	if (weapon_shots<=0) then
		if (attack==1) then
			useweapon(1)
			weapon_shots=weapon_shots+1
			playerstate(0,state_invisible,1)
			playsound(lca.invis.sfx_heal)
			x=getplayerx(0)
			y=getplayery(0)+3
			particle(p_muzzle,x,y)
			particlesize(1,1)
			particlecolor(255,255,255)
			particlealpha(1.0)
			particlefadealpha(0.01)
			particle(p_muzzle,x,y)
			particlesize(1,2)
			particlecolor(255,255,255)
			particlealpha(1.0)
			particlefadealpha(0.02)
			particlerotation(0)
			for j=1,15,1 do
				particle(p_flare,x-10.0+math.random()*20.0,y+math.random()*10.0)
				particlesize(3.0,3.0)
				particlecolor(255,255,255)
				particlespeed(0,math.random(2,15)*-0.1)
				particlefadealpha(0.01)
			end
		end
	end
end